
from pprint import pprint
import pika
import os
import json

class RPC_Server(object):

    def __init__(self, queue_name, integration_service):
        self.queue_name = queue_name
        self.url = os.environ.get('CLOUDAMQP_URL', 'amqp://tvmjkfee:0BCkrC2idZZJcrCSCXDsoVpd1_VWisUh@emu.rmq.cloudamqp.com/tvmjkfee')
        self.params = pika.URLParameters(self.url)
        self.connection = pika.BlockingConnection(self.params)
        self.channel = self.connection.channel()
        self.channel.queue_declare(queue=self.queue_name)
        self.integration_service = integration_service
        

    def on_request(self,ch, method, props, body):

        data = json.loads(body)

        response = self.integration_service.do(data)

        ch.basic_publish(exchange='',
                            routing_key=props.reply_to,
                            properties=pika.BasicProperties(correlation_id = \
                                                                props.correlation_id,
                                                                content_type = "application/json"),
                            body=json.dumps(response))
            
        ch.basic_ack(delivery_tag = method.delivery_tag)
        
    def start(self):

        self.channel.basic_qos(prefetch_count=1)

        self.channel.basic_consume(self.queue_name, self.on_request, auto_ack=True )
        
        print(" [x] Awaiting RPC requests at: "+self.queue_name)
        
        self.channel.start_consuming()
    